/*
 * interface to mac mail check core routines
 * by Aaron Wohl (aw0g+@andrew.cmu.edu) jul 1990
 * Carnegie-Mellon University
 * Special Projects
 * Pittsburgh, PA 15213-3890
 * (412)-268-5032
 */



#define NUM_serv_hosts (2)

#define MK_HOST(p1,p2,p3,p4) ((p1<<24)+(p2<<16)+(p3<<8)+p4)


#define EV_error 	0
#define EV_retrans	1
#define EV_remind	2
#define EV_NUM		3

#define EV_NOTHING	0L		/*value of ev_event when not active*/
struct mmc_event_R {
	long ev_time;			/*time at which to do something for the error system*/
	void (*ev_event)();		/*event to do*/
};
typedef struct mmc_event_R mmc_event,*mmc_event_pt;

/*
 * private state for debugging
 */
struct mmc_priv_state_R {
	short ip_ref;			/*refnum of up driver or 0 if none*/
	short cur_host;			/*NUM_serv_hosts index of current host*/
	short packet_waiting;	/*there is an unread packet waiting*/
	short change_count;		/*gms change counts for text_buf*/
	short last_rcv_error;	/*error number for last bogus input packet*/
	mmc_event ev[EV_NUM];	/*number of delayed events*/

	long server_poll;		/*min poll time for current server*/
	long unans_queries;		/*number of queries sent w/o an answer*/
	long seq_no;			/*send sequence number*/
	void *udp_buf;			/*pointer to udp input buffer*/
	long last_recv_host;
	unsigned short last_recv_port;
};
typedef struct mmc_priv_state_R mmc_priv_state,*mmc_priv_state_pt;

struct mmc_read_result_R {
	char *buf;			/*[out]buffer with recieved data*/
	int buf_size;		/*[out]how much valid data was read*/
	long hostn;			/*[out]host read from*/
	int portn;			/*[out]port read from*/
};
typedef struct mmc_read_result_R mmc_read_result,*mmc_read_result_pt;


void mmc_tick(void);
void mmc_uninit(void);
int mmc_init(void);
int mmc_set_state(mmc_state_pt new_state);
int mmc_get_state(mmc_state_pt old_state,mmc_priv_state_pt *active_priv_state);
int mmc_setmmuser(mmc_state_pt s,mmc_priv_state_pt *active_priv_state);
void textify_error(void);

/*
 * error returns from control routine
 */
#define MMCE_bad_maj	-1000	/*major version in set packet doesn't match driver*/
#define xMMCE_naminhibit	-1001	/*no names where found, perhaps mail program needs to set one*/
#define MMCE_noopen		-1001	/*driver wasn't properly opened*/


struct mmc_gl_t_R {
	mmc_state cs;		/*current exportable state*/
	mmc_priv_state cps;	/*current private state*/
};
typedef struct mmc_gl_t_R mmc_gl_t,*mmc_gl_t_pt;

#define gTURN_OFF_FLAGS(xx_fl) TURN_OFF_FLAGS(mmc_gl.cs,xx_fl)
#define gTURN_ON_FLAGS(xx_fl) TURN_ON_FLAGS(mmc_gl.cs,xx_fl)
#define gFLSET(xx_fl) FLSET(mmc_gl.cs,xx_fl)

extern mmc_gl_t mmc_gl;

#define MIN_REMIND imax(((mmc_gl.cps.server_poll)+1*MINS+10*SECS),ABS_MIN_POLL)
